unit uFTestTChartSerieRegionPattern;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TeEngine, TeeSurfa, TeePoin3, ExtCtrls, TeeProcs, Chart,
  Spin, TeeSeriesRegion, Series;

type
  TFTestTChartLongCanvas = class(TForm)
    Chart: TChart;
    PnlButtons: TPanel;
    BtnPrint: TButton;
    Series1: TLineSeries;
    ChartTool1: TSeriesRegionTool;
    Label1: TLabel;
    SpeNbPages: TSpinEdit;
    procedure BtnPrintClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FTestTChartLongCanvas: TFTestTChartLongCanvas;

implementation

{$R *.dfm}

uses Printers;

procedure TFTestTChartLongCanvas.FormShow(Sender: TObject);
begin
  Series1.FillSampleValues(50);
end;


procedure TFTestTChartLongCanvas.BtnPrintClick(Sender: TObject);
  var
    BakDevMode: TDeviceMode;

  function CheckPdfCreatorPresent: Boolean;
  begin
    Result := Printer.Printers.IndexOf('PDFCreator') <> -1;
    if not Result then
      MessageDlg( 'PDFCreator Printer not found !'+#13+#10+
                   'Please install or rename it ''PDFCreator''', mtInformation, [mbOK], 0);
  end;
  procedure SetPrinterPaperSizeToA4(FPrinter: TPrinter);
  var
    FDevice: array[0..1023] of char;
    FDriver: array[0..1023] of char;
    FPort: array[0..1023] of char;
    DeviceMode: HGLOBAL;
    DevMode: PDeviceMode;
  begin
    FPrinter.GetPrinter(FDevice, FDriver, FPort, DeviceMode);
    DevMode := GlobalLock(DeviceMode);
    try
      Move(DevMode^, BakDevMode, SizeOf(TDeviceMode));
      if  ((DevMode^.dmFields and DM_PAPERSIZE) = DM_PAPERSIZE) then
      begin
        DevMode^.dmFields := DevMode^.dmFields or DM_PAPERSIZE;
        DevMode^.dmPaperSize := DMPAPER_A4_TRANSVERSE;
      end;
      FPrinter.SetPrinter(FDevice, FDriver, FPort, DeviceMode);
    finally
      GlobalUnlock(DeviceMode);
    end;
  end;

var
  tmpMeta : TMetaFile;
  PDFFileName : String;

	rc,rd : TRect;

  ii,nb : integer;
  AZoomFact: integer;
  bmp : TBitmap;
begin
	// Exit Conditions
  if not CheckPdfCreatorPresent() then Exit;

  nb := SpeNbPages.Value;

  Printer.PrinterIndex := Printer.Printers.IndexOf('PDFCreator');
  SetPrinterPaperSizeToA4(TPrinter(Printer));

  With ChartTool1.Brush.Image do
  begin
    bmp := TBitmap.Create;
    bmp.Assign(Bitmap);
    AZoomFact := 4;
    Bitmap.Width := AZoomFact*Bitmap.Width;
    Bitmap.Height := AZoomFact*Bitmap.Height;
    Bitmap.Canvas.StretchDraw(Rect(0,0,AZoomFact*Bitmap.Width,AZoomFact*Bitmap.Height),Bitmap);
  end;

  Chart.Refresh;
  Chart.Align := alNone;
  Chart.Width:= Printer.PageWidth div 5;
  Chart.Height:= nb * (Printer.PageWidth div 5);


  // File Name
  PDFFileName := 'TestTChartSerieRegionPattern_';
  PDFFileName := PDFFileName+'_' + FormatDateTime('YYYY-MM-DD_HH#mm',Now) + '.pdf';
  PDFFileName := StringReplace(PDFFileName,'#','h',[rfReplaceAll]);
  PDFFileName := StringReplace(PDFFileName,'+','m',[rfReplaceAll]);

  try
    try
      TPrinter(Printer).Title:= PDFFileName;
      Printer.BeginDoc;

			rc := Chart.ClientRect;
      tmpMeta := Chart.TeeCreateMetafile(true, rc);

      rd.Left 	:= 0;
      rd.Top 		:= 0;
      rd.Right 	:= Printer.PageWidth;
      rd.Bottom := nb * Printer.PageHeight;

      ii	:= 0;
      while ii < nb do
      begin
      	if ii > 0 then
        begin
	        Printer.NewPage;
          rd.Top := rd.Top - Printer.PageHeight;
          rd.Bottom := rd.Bottom - Printer.PageHeight;
        end;
        Printer.Canvas.StretchDraw(rd,tmpMeta);
        inc(ii);
      end;
      tmpMeta.Free;

      Printer.EndDoc;
    except
      Printer.Abort;
    end;
  finally
    Chart.Align := alClient;

    With ChartTool1.Brush.Image do
    begin
      Bitmap.Assign(bmp);
      bmp.Free;
    end;
  end;
end;


end.
